import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import swarm.activity.*;
import swarm.Selector;
import swarm.collections.*;

public class Bug extends SwarmObjectImpl {
    int tendX, tendY; // AOi񂾕
    int xPos, yPos;
    int worldXSize, worldYSize;
    int spiralFlag;
    int semiSpiralFlag;
    int semiSpiralRate;
    double spiralIn, spiralOut;
    FoodSpace foodSpace;
    PheromoneSpace pheromoneSpace;
    PheromoneOnGround pheromoneOnGround;
    Grid2d world;
    int haveEaten; // haveEaten == 1iA͉aĂjhaveEaten == 0iA͉aĂȂj

    int colonySize;
    int amountOfReleasingPheromone;
    double awayFromColonyRate;
    double turnRate;
    double distanceFC, distanceAC;
    
    public Bug(Zone aZone){
	super(aZone);
    }
    
    public Object setWorld$Food(Grid2d w,FoodSpace f,PheromoneSpace h,PheromoneOnGround p){
	haveEaten = 0;
	world = w;
	foodSpace = f;
	pheromoneSpace = h;
	pheromoneOnGround = p;
	tendX = 0;
	tendY = 0;
	worldXSize = world.getSizeX();
	worldYSize = world.getSizeY();
	spiralFlag = 0;
	semiSpiralFlag = 0;
	semiSpiralRate = 0;
	return this;
    }

    public void setBugParametar(int co, int am, double aw, double tu){
	colonySize = co;
	amountOfReleasingPheromone = am;
	awayFromColonyRate = aw;
	turnRate = tu;
    }

    public void setBugSpiral(int sflag){
	spiralFlag = sflag;
    }
    public void setBugSemiSpiral(int ssflag){
	semiSpiralFlag = ssflag;
    }
    public void setBugSemiSpiralRate(int ssrate){
	semiSpiralRate = ssrate;
    }
    public void setInner(double inner){
	spiralIn = inner;
    }
    public void setOuter(double outer){
	spiralOut = outer;
    }
	
    
    public Object setX$Y(int x, int y){
	xPos = x;
	yPos = y;
	return this;
    }
    
    public Object setWorldSizeX$Y(int xSize, int ySize){
	worldXSize=xSize;
	worldYSize=ySize;
	return this;
    }
			
    public void step(){

	int newX,newY;

	/*
	 * aXVۂɁAaƃAdȂꍇ
	 * aĂȂԂɂāAɖ߂
	 */
	turnToColony();		
	/*
	 * AaĂȂꍇ
	 */
	if ( haveEaten == 0 )
	    {   
		/*
		 * S񂵂āAaΉaHׂ
		 */
		eatFood();
		if ( haveEaten == 1 ) {
		    pheromoneOnGround.putValue$atX$Y
			(pheromoneOnGround.getValueAtX$Y(xPos,yPos)
			 + amountOfReleasingPheromone, xPos, yPos);
		    
		/*
		 * aɐڂĂȂꍇ
		 */
		} else {
		    /*
		     * tFɂA
		     * S񂵂āAtFZɈړ
		     *
		     * 痣ꂽɂ͐i݂₷
		     */
		    if (pheromoneSpace.getValueAtX$Y(xPos,yPos) > 0) {
			proceedOnPheromone();
		    /*
		     * AtFɂȂꍇ
		     */
		    } else {
			proceedNotOnPheromone();
		    }
		}
	    }
	
	/*
	 * AaĂꍇ
	 * aɋ߂Âił낤jɁAtFo
	 */
	else
	    {
		/*
		 * ɗאڂĂΉa^яIƔf
		 */
		distanceFC = ((xPos - worldXSize/2)*(xPos - worldXSize/2) + (yPos - worldYSize/2)*(yPos - worldYSize/2))/((colonySize+1)*(colonySize+1));
		distanceAC = Math.pow((xPos - worldXSize/2)*(xPos - worldXSize/2) + (yPos - worldYSize/2)*(yPos - worldYSize/2), 0.5)/(worldXSize/2);
		if (distanceFC < 1)
		    {
			haveEaten = 0;
			tendX = - tendX;
			tendY = - tendY;
		    }
		else
		    {
			returnToHomeSpiral();
		    }
	    }
    }
    
    private void turnToColony(){
	if (foodSpace.getValueAtX$Y(xPos,yPos) == 1){
	    haveEaten = 0;
	    world.putObject$atX$Y(null,xPos,yPos);
	    xPos = worldXSize/2;
	    yPos = worldYSize/2;
	    tendX = tendY = 0;
	    world.putObject$atX$Y(this,xPos,yPos);
	}
    }

    private void eatFood(){
	
	int newX, newY;
	
	if (foodSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,(yPos+1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = 1;
	    tendY = 1;
	    
	    newX = (xPos+1 + worldXSize) % worldXSize;
	    newY = (yPos+1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,yPos) == 1) {
	    
	    tendX = 1;
	    tendY = 0;
	    
	    newX = (xPos+1 + worldXSize) % worldXSize;
	    newY = (yPos + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,(yPos-1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = 1;
	    tendY = -1;
	    
	    newX = (xPos+1 + worldXSize) % worldXSize;
	    newY = (yPos-1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y(xPos,(yPos+1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = 0;
	    tendY = 1;
	    
	    newX = (xPos + worldXSize) % worldXSize;
	    newY = (yPos+1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y(xPos,(yPos-1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = 0;
	    tendY = -1;
	    
	    newX = (xPos + worldXSize) % worldXSize;
	    newY = (yPos-1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,(yPos+1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = -1;
	    tendY = 1;
	    
	    newX = (xPos-1 + worldXSize) % worldXSize;
	    newY = (yPos+1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,yPos) == 1) {
	    
	    tendX = -1;
	    tendY = 0;
	    
	    newX = (xPos-1 + worldXSize) % worldXSize;
	    newY = (yPos + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	} else if (foodSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,(yPos-1+worldYSize)%worldYSize) == 1) {
	    
	    tendX = -1;
	    tendY = -1;
	    
	    newX = (xPos-1 + worldXSize) % worldXSize;
	    newY = (yPos-1 + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
		foodSpace.putValue$atX$Y(0,xPos,yPos);
		haveEaten=1;
	    }
	}
    }

    private void proceedOnPheromone(){

	int newX, newY;
	int xProposed, yProposed; // xProposed, yProposed == -1, 0 or 1	
	int pheromoneDensity;
	int tempDensity;
	int x = 1;
	int y = 1;
	int x0 = 0;
	int y0 = 0;
	
	if ( xPos < worldXSize/2 ) x = 0;
	if ( yPos < worldYSize/2 ) y = 0;

	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) > (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( xPos - worldXSize/2 < 0 ) x0 = -1;
	    else x0 = 1;
	}
	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) < (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( yPos - worldYSize/2 < 0 ) y0 = -1;
	    else y0 = 1;
	}
	
	xProposed = tendX;
	yProposed = tendY;
	pheromoneDensity = pheromoneSpace.getValueAtX$Y(( xPos + xProposed + worldXSize ) % worldXSize, ( yPos + yProposed + worldYSize ) % worldYSize);
	
	/*
	 * 牓ɌiSj̃tF͑傫
	 * iƔfQ́AawayFromColonyRate{AtF傫
	 * Q́AawayFromColonyRate^2{AtF傫j
	 * Oij̃tF͏
	 * íA1/awayFromCokony^2{AtFj
	 */
	    
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,(yPos+1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == 1 | x-1 == 1 ) && ( y == 1 | y-1 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( x0 == 1 | y0 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == 1 && - tendY == 1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = 1;
	    yProposed = 1;
	    pheromoneDensity = tempDensity;
	} 
	    
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,(yPos+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == 1 | x-1 == 1 ) && ( y == 0 | y-1 == 0 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( y0 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == 1 && - tendY == 0 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = 1;
	    yProposed = 0;
	    pheromoneDensity = tempDensity;
	} 
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos+1+worldXSize)%worldXSize,(yPos-1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == 1 | x-1 == 1 ) && ( y == -1 | y-1 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( x0 == 1 | y0 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == 1 && - tendY == -1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = 1;
	    yProposed = -1;
	    pheromoneDensity = tempDensity;
	} 
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos+worldXSize)%worldXSize,(yPos-1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == 0 | x-1 == 0 ) && ( y == -1 | y-1 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( y0 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == 0 && - tendY == -1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = 0;
	    yProposed = -1;
	    pheromoneDensity = tempDensity;
	}
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,(yPos-1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == -1 | x-1 == -1 ) && ( y == -1 | y-1 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( x0 == -1 | y0 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == -1 && - tendY == -1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = -1;
	    yProposed = -1;
	    pheromoneDensity = tempDensity;
	}
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,(yPos+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == -1 | x-1 == -1 ) && ( y == 0 | y-1 == 0 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( x0 == -1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == -1 && - tendY == 0 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = -1;
	    yProposed = 0;
	    pheromoneDensity = tempDensity;
	}
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos-1+worldXSize)%worldXSize,(yPos+1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == -1 | x-1 == -1 ) && ( y == 1 | y-1 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( x0 == -1 | y0 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == -1 && - tendY == 1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = -1;
	    yProposed = 1;
	    pheromoneDensity = tempDensity;
	}
	
	tempDensity = pheromoneSpace.getValueAtX$Y((xPos+worldXSize)%worldXSize,(yPos+1+worldYSize)%worldYSize);
	if ( tempDensity != 0 && ( x == 0 | x-1 == 0 ) && ( y == 1 | y-1 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( tempDensity != 0 && ( y0 == 1 ) )
	    tempDensity = (int)(tempDensity * awayFromColonyRate);
	if ( - tendX == 0 && - tendY == 1 ) tempDensity = (int)(tempDensity / (awayFromColonyRate*awayFromColonyRate));
	if (pheromoneDensity < tempDensity) {
	    xProposed = 0;
	    yProposed = 1;
	    pheromoneDensity = tempDensity;
	}
	
	tendX = xProposed;
	tendY = yProposed;
	
	newX = xPos + tendX;
	newY = yPos + tendY;
	
	newX = (newX + worldXSize) % worldXSize;
	newY = (newY + worldYSize) % worldYSize;
	
	if (world.getObjectAtX$Y(newX,newY) == null){
	    world.putObject$atX$Y(null,xPos,yPos);
	    xPos = newX;
	    yPos = newY;
	    world.putObject$atX$Y(this,newX,newY);
	
	/*
	 * sꏊɃAꍇA牓ɐiނ悤Ɏ݂
	 */
	} else {
	    
	    tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(x-1,x);
	    tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(y-1,y);

	    newX = xPos + tendX;
	    newY = yPos + tendY;
	    
	    newX = (newX + worldXSize) % worldXSize;
	    newY = (newY + worldYSize) % worldYSize;
	    
	    if (world.getObjectAtX$Y(newX,newY) == null){
		world.putObject$atX$Y(null,xPos,yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
	    }
	}
	
    }
    
    private void proceedNotOnPheromone(){
	
	int newX, newY;

	// aĂ炸tFɂȂꍇ́A(1-turnRate)(1-turnRate)̊mŒi
	
	if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < turnRate)
	    tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
	if (Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0) < turnRate)
	    tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
	
	newX = xPos + tendX;
	newY = yPos + tendY;
	
	newX = (newX + worldXSize) % worldXSize;
	newY = (newY + worldYSize) % worldYSize;
	
	if (world.getObjectAtX$Y(newX,newY) == null){
	    world.putObject$atX$Y(null,xPos,yPos);
	    xPos = newX;
	    yPos = newY;
	    world.putObject$atX$Y(this,newX,newY);
	}
	
    }

    private void returnToHome(){
	
	int newX, newY;
	int x = -1;
	int y = -1;
	int x0 = 0;
	int y0 = 0;
	
	/*
	 * ɋ߂ÂQɃ_Ɉړ
	 */
	if ( xPos < worldXSize/2 ) x = 0;
	if ( yPos < worldYSize/2 ) y = 0;
	
	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) > (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( xPos - worldXSize/2 < 0 ) x0 = 1;
	    else x0 = -1;
	}
	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) < (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( yPos - worldYSize/2 < 0 ) y0 = 1;
	    else y0 = -1;
	}
	
	tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(x,x+1);
	tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(y,y+1);
	
	if ( x0 != 0 && y0 == 0 ) tendX = x0;
	if ( x0 == 0 && y0 != 0 ) tendY = y0;

	newX = xPos + tendX;
	newY = yPos + tendY;
	
	newX = (newX + worldXSize) % worldXSize;
	newY = (newY + worldYSize) % worldYSize;
	
	
	if (world.getObjectAtX$Y(newX,newY) == null && foodSpace.getValueAtX$Y(newX,newY) == 0)
	    {
		world.putObject$atX$Y(null,xPos,yPos);
		pheromoneOnGround.putValue$atX$Y
		    (pheromoneOnGround.getValueAtX$Y(xPos,yPos)
		     + amountOfReleasingPheromone, xPos, yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
	    }
	
	/*
	 * sƂꏊɉaA܂́ÃA
	 * âȂփ_Ɉړ
	 */
	
	else
	    {
		do {
		    tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
		    tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
		    
		    newX = xPos + tendX;
		    newY = yPos + tendY;
		    
		    newX = (newX + worldXSize) % worldXSize;
		    newY = (newY + worldYSize) % worldYSize;
		    
		}while (foodSpace.getValueAtX$Y(newX,newY) != 0 );
		
		if (world.getObjectAtX$Y(newX,newY) == null){
		    world.putObject$atX$Y(null,xPos,yPos);
		    xPos = newX;
		    yPos = newY;
		    world.putObject$atX$Y(this,newX,newY);
		}
	    }
	
    }

    private void returnToHomeSpiral(){
	int turnFlag;
	int newX, newY;
	int x = -1;
	int y = -1;
	int x0 = 0;
	int y0 = 0;
	
	/*
	 * ɋ߂ÂQɃ_Ɉړ
	 */
	if ( xPos < worldXSize/2 ) x = 0;
	if ( yPos < worldYSize/2 ) y = 0;
	
	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) > (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( xPos - worldXSize/2 < 0 ) x0 = 1;
	    else x0 = -1;
	}
	if ( (xPos-worldXSize/2)*(xPos-worldXSize/2) < (yPos-worldYSize/2)*(yPos-worldYSize/2) ) {
	    if ( yPos - worldYSize/2 < 0 ) y0 = 1;
	    else y0 = -1;
	}
	
	tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(x,x+1);
	tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(y,y+1);
	
	if ( x0 != 0 && y0 == 0 ) tendX = x0;
	if ( x0 == 0 && y0 != 0 ) tendY = y0;
	newX = xPos + tendX;
	newY = yPos + tendY;

	turnFlag = Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,99);
	if(semiSpiralFlag == 1){
	    if(turnFlag < semiSpiralRate){
		newX = xPos - tendY;
		newY = yPos + tendX;
	    }else{
		newX = xPos + tendX;
		newY = yPos + tendY;
	    }
	}else if(distanceAC < spiralOut && distanceAC >= spiralIn && spiralFlag == 1){
	    newX = xPos - tendY;
	    newY = yPos + tendX;
	}

	newX = (newX + worldXSize) % worldXSize;
	newY = (newY + worldYSize) % worldYSize;
	
	
	if (world.getObjectAtX$Y(newX,newY) == null && foodSpace.getValueAtX$Y(newX,newY) == 0)
	    {
		world.putObject$atX$Y(null,xPos,yPos);
		pheromoneOnGround.putValue$atX$Y
		    (pheromoneOnGround.getValueAtX$Y(xPos,yPos)
		     + amountOfReleasingPheromone, xPos, yPos);
		xPos = newX;
		yPos = newY;
		world.putObject$atX$Y(this,newX,newY);
	    }
	
	/*
	 * sƂꏊɉaA܂́ÃA
	 * âȂփ_Ɉړ
	 */
	
	else
	    {
		do {
		    tendX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
		    tendY = Globals.env.uniformIntRand.getIntegerWithMin$withMax(-1,1);
		    
		    
		    newX = xPos + tendX;
		    newY = yPos + tendY;

		    turnFlag = Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,99);
		    if(semiSpiralFlag == 1){
			if(turnFlag < semiSpiralRate){
			    newX = xPos - tendY;
			    newY = yPos + tendX;
			}else{
			    newX = xPos + tendX;
			    newY = yPos + tendY;
			}
		    }else if(distanceAC < spiralOut && distanceAC >= spiralIn && spiralFlag == 1){
			newX = xPos - tendY;
			newY = yPos + tendX;
		    }
		    
		    newX = (newX + worldXSize) % worldXSize;
		    newY = (newY + worldYSize) % worldYSize;
		    
		}while (foodSpace.getValueAtX$Y(newX,newY) != 0 );
		
		if (world.getObjectAtX$Y(newX,newY) == null){
		    world.putObject$atX$Y(null,xPos,yPos);
		    xPos = newX;
		    yPos = newY;
		    world.putObject$atX$Y(this,newX,newY);
		}
	    }
	
    }
    
    public Object report(){
	if(haveEaten==1)
	    System.out.println("I found food at X = " + xPos + " Y = " + yPos +"!");
	return this;
    }
    
    public Object drawSelfOn(Raster r){
	r.drawPointX$Y$Color(xPos,yPos,(byte)2);
	return this;
    }
}
